import es, gamethread, playerlib

# Speed at which health and armor decrease. The lower the value, the faster.
sd_speed = 0.01

players = {}
es.ServerVar("smoothdamage_ver", 1.0).makepublic()

def player_hurt(event_var):
    global players
    if not event_var["userid"] in players:
        players[event_var["userid"]] = {}
        players[event_var["userid"]][0] = None
        players[event_var["userid"]][1] = None
    if not players[event_var["userid"]][0] == None:
        health = int(players[event_var["userid"]][0]) - int(event_var["dmg_health"])
    else:
        health = event_var["health"]
        players[event_var["userid"]][0] = int(health) + int(event_var["dmg_health"])
    if not players[event_var["userid"]][1] == None:
        armor = int(players[event_var["userid"]][1]) - int(event_var["dmg_armor"])
    else:
        armor = event_var["armor"]
        players[event_var["userid"]][1] = int(armor) + int(event_var["dmg_armor"])
    if health > 0:
        smoothhealth(event_var["userid"], players[event_var["userid"]][0], health)
    if armor > 0:
        smootharmor(event_var["userid"], players[event_var["userid"]][1], armor)
    players[event_var["userid"]][0] = health
    players[event_var["userid"]][1] = armor

def smoothhealth(userid, from_health, to_health):
    if not userid == None or not from_health == None or not to_health == None:
        from_health = int(from_health)
        to_health = int(to_health)
        if from_health > to_health:
            from_health -= 1
            es.setplayerprop(userid, "CBasePlayer.m_iHealth", from_health)
            gamethread.delayedname(float(sd_speed), "sd_%s" % userid, smoothhealth, (userid, from_health, to_health))

def smootharmor(userid, from_armor, to_armor):
    if not userid == None or not from_armor == None or not to_armor == None:
        from_armor = int(from_armor)
        to_armor = int(to_armor)
        if from_armor > to_armor:
            from_armor -= 1
            es.setplayerprop(userid, "CCSPlayer.m_ArmorValue", from_armor)
            gamethread.delayedname(float(sd_speed), "sa_%s" % userid, smootharmor, (userid, from_armor, to_armor))

def player_spawn(event_var):
    global players
    if not event_var["userid"] in players:
        players[event_var["userid"]] = {}
    players[event_var["userid"]][0] = es.getplayerprop(event_var["userid"], "CBasePlayer.m_iHealth")
    players[event_var["userid"]][1] = es.getplayerprop(event_var["userid"], "CCSPlayer.m_ArmorValue")
    gamethread.cancelDelayed("sh_%s" % event_var["userid"])
    gamethread.cancelDelayed("sa_%s" % event_var["userid"])

def player_death(event_var):
    gamethread.cancelDelayed("sh_%s" % event_var["userid"])
    gamethread.cancelDelayed("sa_%s" % event_var["userid"])